
libname t '.';

data temp;
 set t.tomhs;
 if group = 6 then active = 2; else active = 1;
 if group = 6 then activex = 1; else activex = 0;
run;

%let endpoints = clinical second;
%let tendpoints = clyrs seyrs;

%breakdn(data=temp, class=active 2, var = clinical, out=out0);
%breakdn(data=temp, class=active 2, var = &endpoints, out=e);
%breakdn(data=temp, class=active 2, var = &tendpoints, out=t);

data r;
 set e (keep=sum1-sum4);
 set t (keep=sum1-sum4 rename = (sum1-sum4=tsum1-tsum4));
 array e{4} sum1-sum4;
 array t{4} tsum1-tsum4;
 array r{4} r1-r4;
 do i = 1 to 4;
  r{i} = 100*e{i}/t{i};
 end;
 keep sum1-sum4 r1-r4;
run;

%phregp(data=temp, dlist=&endpoints, tlist=&tendpoints, ilist=activex, strata=clinic,
        factor=activex,out=hr);

%wreport(htmlfile = "&pname..htm");
%colset (22 9 9 2x 9 9 2x 15);

%move('<br>Example 4. Clinical Event Rates for Active and Placebo Groups in TOMHS<br>&nbsp', col=1-0,
      line=1, fontsize=11pt,fontweight=bold);
%move("pn=&pname rundate=&sysdate9", col=1-0, line=100, center=2);
%move('<u><b>Notes&#58;</b></u> &nbsp' , col=1-0, line=92, center=2);
%move('Active':'Placebo':'Active vs Placebo', col=2-3 4-5 6, line=7, fontweight=bold);
%move('Events':'Rate/100 PY', col=2.5, line=9, fontweight=bold);
%move('HR (95% CI)', col=6, line=9, fontweight=bold);
%move('No. Participants', col=1, center=2, line=52, fontweight=bold, fontstyle=italic);

%move('Clinical Event', col=1, center=2, line=9, fontweight=bold, fontstyle=italic);
%move('Primary CVD':'Primary or Secondary CVD', col=1, center=2, indent=1, line=12L2);

set out0;
%nmove(n1-n2, col=2-3 4-5, line=52, fmt=5.0, fontweight=bold);

set r;
%nmove(sum1-sum4, col=2 4, line=12L2, fmt=5.0);
%nmove(r1-r4, col=3 5);

set hr; 
%nmove(r1-r2 L1-L2 u1-u2, col=6, line=12L2, combine=y, fchar=3, fmt=6.2 6.2 6.2); 

stop;
run;
%makehtml(width=700px);


