%macro freqdis(data=_last_,class=,out=&class,one=one,where=);
 
/*
   macro FREQDIS calculates and stores counts, percentages,
   cumulative counts, and cumulative percentages.
 
           ******** example of call *******
 
     %freqdis(class=sex 2T cage 5T, out=agesex) ;
      T indicate totals (optional)
      variables stored as n?, cn?, p? and cp?
      variables stored with second class variable
      changing fastest
 
*/
 
 
%let class = %upcase(&class);
 
%let class1 = %scan(&class,1);
%let class2 = %scan(&class,3);
%let nclass = 2;
%if &class2 = %str() %then %let nclass=1;
%let ncat1  = %scan (%scan(&class,2),1,T);
%let ncat2  = %scan (%scan(&class,4),1,T);
%if %index( %scan(&class,2),T) gt 0 %then %let tot1=1;
%else %let tot1=0;
%if %index( %scan(&class,4),T) gt 0 %then %let tot2=1;
%else %let tot2=0;
 
%let class = &class1 &class2 ;
 
%if &ncat2 = %str() %then %do ;
 %let ncat2  = 0;
 %let tot2 = 1 ;
%end;
%if &class2 = %str() %then %let class2 = dumbvar;
 
proc summary data=&data;
 class &class ;
 var &class1 ;
 output out = &out n = n0;
 &where;
data &out;
 
 dumbvar = 1;
 %let ncat1= %eval(&ncat1+&tot1);
 %let ncat2= %eval(&ncat2+&tot2);
 %let ncat = %eval(&ncat1*&ncat2);
 
 array xn(*) n1-n&ncat;
 array cn(*) cn1-cn&ncat;
 array p(*) p1-p&ncat;
 array cp(*) cp1-cp&ncat;
 keep  n1-n&ncat cn1-cn&ncat p1-p&ncat cp1-cp&ncat;
 
 do i = 1 to &ncat;
  xn(i) = 0 ; p(i) = 0; cp(i) = 0;
 end;
 
 do i = 1 to totobs;
  set &out point = i nobs=totobs ;
  if &class1 = . and &tot1 ne 1 then goto skip;
  if &class2 = . and &tot2 ne 1 then goto skip;
  if &class1 = . then &class1 = &ncat1;
  if &class2 = . then &class2 = &ncat2;
  index = (&ncat2*(&class1-1))+(&class2);
  xn(index) = n0;
  skip:
 end;
 
 sum =0;
%if &ncat2 = 1 %then %let ncat2 = &ncat;
 do i = 1 to &ncat;
  cn(i) = sum + xn(i);
  sum = sum + xn(i) ;
  if mod(i,&ncat2) = 0 then do;
   sum = 0;
   if &tot2 = 1 and (&nclass = 2 or &tot1 =1) then cn(i) = cn(i-1);
  end;
 end;
 
 do i = 1 to &ncat;
  dindx = &ncat2 * int((i-1)/&ncat2) + &ncat2;
  p(i) = 100*xn(i)/cn(dindx);
  cp(i) = 100*cn(i)/cn(dindx);
 end;
 output;
 stop;
%mend;
 
