

* Gives standard Pearson Chi-square and p-values;

%macro pchisqp(data=_last_, dlist=, group=, where=,  pdata= );                                                  
                                                                                
                                                                                
%ntok(&dlist,ndep,vname=dlist);

ods output ChiSq = _ChiSq_ ;
proc freq data=&data ;                                                          
 tables                                                                         
  (&group)*(&dlist)/chisq ;                                                
  &where ;
run;
ods output close;

* Removes rows other than type of test requested;
data _ChiSq_;
 set _ChiSq_; where statistic = 'Chi-Square';
run;

* Puts data in 1-record dataset. If test not done, e.g. no events
  in any group than statistics will be set to missing;

data &pdata; 
 retain p1-p&ndep x1-x&ndep df1-df&ndep;
 array p{*} p1-p&ndep;
 array x{*} x1-x&ndep;
 array xdf{*} df1-df&ndep;

 set _ChiSq_ end=eof;
 %do i = 1 %to &ndep;
  if scan(lowcase(table),-1) = lowcase("&&dlist&i") then do;
  index = &i;
 end;
 %end;
  p{index} = Prob;
  x{index} = Value;
  xdf{index} = DF;

  keep p1-p&ndep x1-x&ndep df1-df&ndep;

  if eof then output; 
run;

proc delete data=_ChiSq_;
run;

%mend;



