/****************************************************************************** 
  Mar 2011 - changed macro to output &plusmn rather than hex value
  Nov 09 - added square brackets as option for formatting 3 numbers
  Nov 2007
  Added parameter color = to move and nmove to allow for font color.
  2006
  Added parameter background = to allow background cell color 
  Jan 2004
  Modified report macros that will create HTML tables along with the text tables. 
  Need macro MAKEHTML

  New parameters for move and nmove (optional):

  Text Display Parameters  
  indent = indent text ( 0=none) 1 ( a little) 2 (more)
  fontfamily = any usual font name (eg Arial)
  fontsize = points size followed by units (usually pt)
  fontweight = normal, or bold
  fontsytle = normal or italic
  lineheight = size of cell in proportion to text size
  textdecoration = underline
  background = #e9e9e9 for shading
  color = red (font color)

  Example Call:

  %move('string1':'string2', col=1 line=2 3,
  fontfamily = Times New Roman,
  fontsize   = 10pt,
  color = blue,
  fontweight = bold,
  fontstyle = italic,
  textdecoration = underline,
  lineheight = 200%);

  Spring 2004
  Modified NMOVE to allow multiple variables to be moved to same column with various
  choices of formatting between the values. Use for html output mostly.

  combine = y (indicats you want to combine values)
  fchar   = 1 (for num1 +/- num2 ) [used for mean +/- SD]
  fchar   = 1C (for num1, num2 ) 
  fhcar   = 2 (for num1 (num2%))[used for n (%) without the % sign)
  fhcar   = 2P(for num1 (num2%))[used for n (%) with the % sign)
  fchar   = 3 (for num1 (num2 - num3) )
  fchar   = 3B (for num1 [num2 - num3] )
  fchar   = 4 (for num1 (num2, num3) )
  fchar   = 4B (for num1 [num2, num3] )

  Example Calls:
  %nmove(r1-r7 L1-L7 u1-u7, col=4, line=12L7, combine=y, fmt=5.2 5.2 5.2, fchar=3);
  %nmove(m1-m7 s1-s7, col=4, line=12L7, combine=y, fmt=5.1 5.1, fchar=1);
  %nmove(sum1-sum7 m1-m7, col=4, line=12L7, combine=y, fmt=5.0 5.1, scaler=1 100, fchar=2P)

  %MACRO MOVE(STRING,UNDER=,LINE=*,COL=*,CENTER=1,MFIRST=L,         
  PAT=100ST/0,DISPLAY=NO,U=, tag=TD,indent=0,
	    fontfamily=d,fontsize=d,fontweight=d,fontstyle=d,
	    textdecoration=d, lineheight=d);    
*******************************************************************************/
   

%MACRO WREPORT(REPFILE=, HTMLFILE=);                                                        
 DATA _NULL_;                                                                   
 FILE &REPFILE PRINT N=PS;                                                      
 %global filetxt filehtml;
 %let filetxt = &repfile;
 %let filehtml = &htmlfile;
%MEND;                                                                          
%MACRO COLSET(CLIST,float=); 

%local i j k m z nx ;
%global pixwidth;
%LET CLIST = %UPCASE(&CLIST);
%LET CSKIP=0;
%LET J=1;
%GLOBAL BC1;
%LET BC1=1;
%let totwidth = 0;
%let lastx = 1; 
%let totskip = 0;
%DO I=1 %TO 100;
 %LET RCOL=%SCAN(&CLIST,&I);
 %IF &RCOL EQ %STR() %THEN %GOTO FINISH;
 %IF %INDEX(&RCOL,X) GT 0 %THEN %DO;
  %LET CSKIP=%SCAN(&RCOL,1,X);
  %let totskip = %eval(&totskip+&cskip);
  %do m = %eval(&lastx+1)  %to %eval(&j-2);
    %let rule&m = 0;
  %end;
  %let lastx = %eval(&j-1);
  %GOTO DONE;
 %END;
 %LET K=%EVAL(&J-1);
 %GLOBAL BC&J;
 %GLOBAL EC&J;
 %let sizecol&j = &rcol;
 %let totwidth = %eval(&totwidth + &rcol);
 %let rule&j = 1;
 %IF &J EQ 1 %THEN %LET EC&J=&RCOL;
 %IF &J GT 1 %THEN %LET EC&J=%EVAL(&&EC&K+&&RCOL+&CSKIP);
 %IF &J GT 1 %THEN %LET BC&J=%EVAL(&&EC&K+1+&CSKIP);
 %LET J=%EVAL(&J+1);
 %LET CSKIP=0;
 %DONE:%END;
%FINISH:                                                                     
 %if &lastx > 1 %then %do;
  %do m = %eval(&lastx+1)  %to %eval(&j-2);
    %let rule&m = 0;
  %end;
 %end;

%LET pixwidth = %eval(&totwidth*10);
%GLOBAL MAXCOL;
%LET MAXCOL = %EVAL(&J-1);
%let twidth = %eval(&&ec&maxcol);
%*LET pixwidth = %eval(&twidth*10);
%let shift = 0;
%if %length(&float) > 0 %then %let shift = %eval((&float-&twidth)/2);


%if %length(&filehtml) > 0 %then %do;
file '_colgroup_.txt' n=1  ;
%end;

%let z = 0;
%do i = 1 %to &maxcol;
 %let bc&i = %eval(&&bc&i + &shift);
 %let ec&i = %eval(&&ec&i + &shift);
 %let z = %eval(&z+1);
 %if %length(&filehtml) > 0 %then %do;
 %if &&rule&i = 1 %then %do;
 %if &i = 1 %then %do;
 put '<COLGROUP align="left" span=' "&z" ' width = ' "%eval(&&sizecol&i *10)>" ;
 %end;
 %if &i > 1 %then %do;
 put '<COLGROUP align="center" span=' "&z" ' width = ' "%eval(&&sizecol&i *10)>" ;
 %end;
  %let z = 0;
 %end;
 %end;
%end;


%MEND COLSET;

%MACRO MOVE(STRING,UNDER=,LINE=*,COL=*,CENTER=1,MFIRST=L,         
            PAT=100ST/0,DISPLAY=NO,U=, tag=TD,indent=0,
	    fontfamily=d,fontsize=d,fontweight=d,fontstyle=d,
	    background=d, color=d,
	    textdecoration=d, lineheight=d)/STMT;    
            
%local i j k w z ;
%LET MFIRST = %UPCASE(&MFIRST) ;                
%LET LINE = %UPCASE(&LINE) ;  
%LET PAT= %UPCASE(&PAT) ;     
%LET DISPLAY = %UPCASE(&DISPLAY);               
%LET CENTER  = %UPCASE(&CENTER);                
%LET U = %UPCASE(&U) ;        
%LET UNDER = %UPCASE(&UNDER) ;                  
%IF &U = Y OR &U = YES %THEN %LET U = 1 ;       
%IF &UNDER = Y OR &UNDER = YES %THEN %LET UNDER = 1 ;             
%IF &CENTER = Y OR &CENTER = YES %THEN %LET CENTER = 1 ;          
%let indent = %eval(&indent*10);
            
%IF &U = 1 %THEN %LET UNDER=1;                  
%IF &DISPLAY EQ YES %THEN %DO;                  
 %PUT STRING=&STRING;         
 %PUT LINE=&LINE;             
 %PUT COL=&COL;               
 %PUT CENTER=&CENTER;         
 %PUT PAT=&PAT;               
%END;       
            
%GLOBAL NPAT;                 
%GLOBAL XPAT;                 
%IF %INDEX(&PAT,*) GT 0 %THEN %GOTO SKIPPAT;    
            
%LET NPAT=%SCAN(&PAT,2,/);    
%LET XPAT=%SCAN(&PAT,1,T N S R);                
%SKIPPAT:   
            
%DO I = 1 %TO 100;            
 %LET CSTR&I=%SCAN(&STRING,&I,:);               
 %IF &&CSTR&I=%STR() %THEN %GOTO DONE;          
 %IF %INDEX(&&CSTR&I,\) GT 0 %THEN %DO;         
  %LET P1 = %BQUOTE( %SCAN(&&CSTR&I,1,\)) ;     
  %LET P3 = %BQUOTE( %SCAN(&&CSTR&I,3,\)) ;     
  %LET CSTR&I = %UNQUOTE(&P1&P3);               
 %END;      
 %IF &DISPLAY = YES %THEN %DO;                  
  %PUT STRING &I &&CSTR&I;    
 %END;      
 %LET NCHAR&I=%EVAL(%LENGTH(&&CSTR&I)-2);       
%END;       
%DONE:%LET NSTR=%EVAL(&I-1);  
            
%* DECOMPOSE LINE NUMBERS AND FIND NUMBER OF LINES;               
%IF %INDEX(&LINE,*) GT 0 %THEN %GOTO SKIPLINE;  
            
%LET Z = 0; 
%GLOBAL NLIN ;                
%LET NLIN = 0;                
%DO I = 1 %TO 100;            
 %LET LL=%SCAN(&LINE,&I,' ') ;                  
 %IF &LL EQ %STR() %THEN %GOTO LDONE3;          
 %IF %INDEX(&LL,L) GT 0 %THEN %DO;              
 %LET NLIN&I=%SCAN(&LL,2,L);  
 %LET SLIN&I=%SCAN(&LL,1,L);  
 %LET Z = %EVAL(&Z+1);        
 %GLOBAL LN&Z;                
 %LET LN&Z=&&SLIN&I;          
 %LET NLIN = %EVAL(&NLIN+1);  
 %LET K = 0;                  
 %DO J= 2 %TO &&NLIN&I ;      
  %LET Z = %EVAL(&Z+1);       
  %LET K = %EVAL(&K+1);       
  %LET NLIN = %EVAL(&NLIN+1); 
  %LET W=%EVAL(&Z-1);         
  %GLOBAL LN&Z;               
  %LET LN&Z=%EVAL(&&LN&W+1);  
  %IF &K EQ &XPAT %THEN %LET LN&Z=%EVAL(&&LN&Z+&NPAT) ;           
  %IF &K EQ &XPAT %THEN %LET K=0;               
  %END;     
 %END;      
 %IF %INDEX(&LL,L) EQ 0 %THEN %DO;              
  %LET Z = %EVAL(&Z+1);       
  %GLOBAL LN&Z;               
  %LET LN&Z = &LL;            
  %LET NLIN = %EVAL(&NLIN+1); 
 %END;      
%END;       
%LDONE3:    
            
%SKIPLINE:  
%IF &DISPLAY = YES %THEN %DO; 
 %DO I = 1 %TO &NLIN;         
   %PUT LINE &I &&LN&I;       
 %END;      
%END;       
%* DECOMPOSE COLUMNS AND FIND NUMBER OF COLUMNS;                  
%IF %INDEX(&COL,*) GT 0 %THEN %GOTO SKIPCOL;    
%LET J=0;   
%DO I=1 %TO 100;              
/* %LET CC=%SCAN(&COL,&I,:);*/                  
 %LET CC=%SCAN(&COL,&I,' ');  
 %IF &CC EQ %STR() %THEN %GOTO DONE3;           
 %IF %INDEX(&CC,.) GT 0 %THEN %DO;              
  %LET RC1=%SCAN(&CC,1,.);    
  %LET RC2=%SCAN(&CC,2,.);    
  %IF &RC2 = %STR(0) %THEN %LET RC2 = &MAXCOL;  
  %DO K= &RC1 %TO &RC2;       
   %LET J=%EVAL(&J+1);        
   %GLOBAL BCOL&J ECOL&J OCOL&J;     
   %LET BCOL&J=&&BC&K;        
   %LET ECOL&J=&&EC&K;        
   %LET OCOL&J= &K;
  %END;     
 %END;      
 %ELSE %IF %INDEX(&CC,-) GT 0 %THEN %DO;        
  %LET J=%EVAL(&J+1);         
  %LET RC1=%SCAN(&CC,1,-);    
  %LET RC2=%SCAN(&CC,2,-);    
  %IF &RC2 = %STR(0) %THEN %LET RC2 = &MAXCOL;  
  %GLOBAL BCOL&J ECOL&J OCOL&J;      
  %LET BCOL&J=&&BC&RC1;       
  %LET ECOL&J=&&EC&RC2;       
  %LET OCOL&J= &CC;
 %END;      
 %ELSE %DO; 
   %LET J=%EVAL(&J+1);        
   %GLOBAL BCOL&J ECOL&J OCOL&J;     
   %LET BCOL&J=&&BC&CC;       
   %LET ECOL&J=&&EC&CC;       
   %LET OCOL&J= &CC;
 %END;      
%END;       
%DONE3:     
%GLOBAL NCOL;                 
%LET NCOL=&J;                 
            
%SKIPCOL:   
            
%LET IL=1;  
%LET IC=1;  
%LET J=0;   

%DO I = 1 %TO &NLIN*&NCOL;    
 %LET J=%EVAL(&J+1);          
 %IF %EVAL(&J-&NSTR) GT 0 %THEN %LET J=1;       
 %LET PCOL=&&BCOL&IC;         
 %LET BCOL=&&BCOL&IC;         
 %LET ECOL=&&ECOL&IC;         
 %let dcol= %eval(&ecol-&bcol + 1);
* DO LOOP FOR HTML FILE;
 %if %length(&filehtml) > 0 %then %do;
 FILE '_tabledata_.txt' n=1 lrecl=500 ;
 PUT &&CSTR&J '09'x  "&&LN&IL" '09'x "&&OCOL&IC" '09'x "&dcol" '09'x "&tag" '09'x "&center" '09'x "&indent" '09'x 
     "&fontfamily" '09'x "&fontsize" '09'x "&fontweight" '09'x "&fontstyle" '09'x 
     "&textdecoration" '09'x "&lineheight" '09'x "&background" '09'x "&color"   ;              
 %end;
 FILE &filetxt print n=ps ;
 %IF &CENTER EQ 1 %THEN %LET PCOL=              
   %EVAL(&PCOL + (&&ECOL&IC+1-&&BCOL&IC-&&NCHAR&J)/2 );           
   %if %eval(&pcol) <= 0 %then %let pcol=1;
 PUT # &&LN&IL @ &PCOL  &&CSTR&J ;              
   %IF &UNDER = 1 AND &CENTER EQ 1 %THEN %DO;   
    UNDER=REPEAT('-',&ECOL-&BCOL-2);            
    PUT # %EVAL(&&LN&IL+1) @ %EVAL(&BCOL+1) UNDER;                
   %END;    
  %IF &UNDER = 1 AND &CENTER NE 1 %THEN %DO;    
    UNDER=REPEAT('-',&ECOL-&BCOL-1);            
   PUT # %EVAL(&&LN&IL+1) @ %EVAL(&BCOL) UNDER; 
  %END;     
 %IF &MFIRST EQ L %THEN %DO;  
  %LET IL=%EVAL(&IL+1);       
  %IF %EVAL(&IL-1) EQ &NLIN %THEN %DO;          
   %LET IL=1;                 
   %LET IC=%EVAL(&IC+1);      
  %END;     
 %END;      
 %IF &MFIRST EQ C %THEN %DO;  
  %LET IC=%EVAL(&IC+1);       
  %IF %EVAL(&IC-1) EQ &NCOL %THEN %DO;          
   %LET IC=1;                 
   %LET IL=%EVAL(&IL+1);      
  %END;     
 %END;      
%END;       
;           

%MEND;      
            
%MACRO NMOVE        
        (VAR,LINE=*,COL=*,FMT=5.1,PAT=100ST/0, ADVL=, SCALER=,center=1,       
         MFIRST=L,SPECIAL1=,SPECIAL2=,DISPLAY=NO,specfmt=,tag=TD,indent=0,
	 fontfamily=d,fontsize=d,fontweight=d,fontstyle=d,    
	 fchar =, background=d, color=d,
	 textdecoration=d, lineheight=d, combine=)/STMT;    

%local i j k z ;

%LET MFIRST = %UPCASE(&MFIRST) ;        
%LET LINE = %UPCASE(&LINE) ;  
%LET PAT= %UPCASE(&PAT) ;     
%let fchar = %upcase(&fchar);
%LET DISPLAY = %UPCASE(&DISPLAY);       
%IF %INDEX(&LINE,#) GT 0 %THEN %LET SPECIAL1=1;   
%IF %INDEX(&LINE,#) GT 0 %THEN %LET LINE=1;       

%IF &DISPLAY= YES %THEN %DO;  
 %PUT VAR=&VAR;     
 %PUT COL=&COL;     
 %PUT LINE=&LINE;   
 %PUT FMT=&FMT;     
%END;     

%GLOBAL NPAT;       
%GLOBAL XPAT;       
%IF %INDEX(&PAT,*) GT 0 %THEN %GOTO SKIPPAT;      
%LET NPAT=%SCAN(&PAT,2,/);    
%LET XPAT=%SCAN(&PAT,1,T N S R);        
%SKIPPAT: 
%LET J=0; 

%DO I = 1 %TO 100;  
 %LET TEMP=%SCAN(&VAR,&I,' ');
 %IF %LENGTH(&TEMP) EQ 0 %THEN  %GOTO DONE;       
 %IF %INDEX(&TEMP,%STR(-)) GT 0 %THEN %DO;        
  %LET ROOT=%SCAN(&TEMP,1,1 2 3 4 5 6 7 8 9);     
  %LET BNUM=%SCAN(&TEMP,1,&ROOT %STR(-));         
  %LET ENUM=%SCAN(&TEMP,2,&ROOT %STR(-));         
  %DO K=&BNUM %TO &ENUM;      
    %LET J=%EVAL(&J+1);       
    %LET VAR&J=&ROOT&K;       
  %END;   
 %END;    
 %ELSE %DO;         
 %LET J=%EVAL(&J+1);
 %LET VAR&J=&TEMP;  
 %END;    
%END;     
%DONE:%LET NVAR=&J; 


%if %length(&combine) > 0 %then %do;
 %do i = 1 %to 100;
  %let fmt&i  = %scan(&fmt,&i,' ');
  %if &&fmt&i = %str() %then %let fmt&i = 5.1;
  %let scaler&i = %scan(&scaler,&i,' ');
  %let temp = %scan(&var,&i,' ');
  %if %length(&temp) = 0 %then %goto donec;
  %if %index(&temp,%str(-)) gt 0 %then
  %do;
   %let root = %scan(&temp,1,1 2 3 4 5 6 7 8 9);
   %let bnum = %scan(&temp,1,&root %str(-));
   %let enum = %scan(&temp,2,&root %str(-));
  %end;
  %else 
  %do;
   %let root = %scan(&temp,1,1 2 3 4 5 6 7 8 9);
   %let bnum = %scan(&temp,1,&root);
   %let enum = &bnum;
  %end;
  %let root&i = &root;
  %let bnum&i = &bnum;
  %let enum&i = &enum;
 %end; 
 %donec:%let ncomb = %eval(&i-1);

 %let bnum = &bnum1;
 %let enum = &enum1;

 %let j = 0;
 %do i = &bnum %to &enum;
  %if &ncomb = 2 %then
  %do;
   %let j = %eval(&j+1);
   %let var&j = cvalue&j; 
   length cvalue&j $80.;
   %if %length(&scaler1) > 0 %then
   %do;
    &root1&i = &root1&i * &scaler1;
   %end;
   %if %length(&scaler2) > 0 %then
   %do;
    &root2&i = &root2&i * &scaler2;
   %end;
   %if &fchar = 1 %then
   %do; 
    *cvalue&j = put (&root1&i,&fmt1)|| ' ' || 'b1'x || ' ' 
                   ||left(put(&root2&i,&fmt2));
    cvalue&j = compbl (put (&root1&i,&fmt1)|| ' ' || '&plusmn;' || ' ' 
                   ||left(put(&root2&i,&fmt2)) );
   %end;
   %else %if &fchar = 1C %then
   %do; 
    cvalue&j = put (&root1&i,&fmt1)|| ', '   
                   ||left(put(&root2&i,&fmt2));
   %end;
   %else %if &fchar = 2 %then
   %do;
    cvalue&j = put (&root1&i,&fmt1)|| ' ' || '(' 
                   ||trim(left(put(&root2&i,&fmt2)))||')';
   %end;
   %else %if &fchar = 2B %then
   %do;
    cvalue&j = '[' || trim(left(put (&root1&i,&fmt1)))|| ', '   
                   ||trim(left(put(&root2&i,&fmt2)))||']';
   %end;
   %else %if &fchar = 2P %then 
   %do;
    cvalue&j = trim(put (&root1&i,&fmt1))|| ' ' || '(' ||trim(left(put(&root2&i,&fmt2)))||'%)';
   %end;
   %let nvar=&j;
   %let fmt = %eval (%scan(&fmt1,1,.) +  %scan(&fmt2,1,.) +11 ) ; 
   %let fmt = &fmt..;
   %let scaler =;
  %end;
  %else %if &ncomb = 3 %then
  %do;
   %let j = %eval(&j+1);
   %let var&j = cvalue&j; 
   length cvalue&j $80.;
   %if %length(&scaler1) > 0 %then
   %do;
    &root1&i = &root1&i * &scaler1;
   %end;
   %if %length(&scaler2) > 0 %then
   %do;
    &root2&i = &root2&i * &scaler2;
   %end;
   %if %length(&scaler3) > 0 %then
   %do;
    &root3&i = &root3&i * &scaler3;
   %end;
   %if &fchar = 3 %then
   %do; 
    cvalue&j = put (&root1&i,&fmt1)|| ' (' || trim(left(put(&root2&i,&fmt2)))||
                   ' - ' || trim(left(put(&root3&i,&fmt3))) ||')';
   %end;
   %else %if &fchar = 4 %then
   %do;
    cvalue&j = put (&root1&i,&fmt1)|| ' (' || trim(left(put(&root2&i,&fmt2)))||
                   ', ' || trim(left(put(&root3&i,&fmt3))) ||')';
   %end;
   %else %if &fchar = 3B %then
   %do;
    cvalue&j = put (&root1&i,&fmt1)|| ' [' || trim(left(put(&root2&i,&fmt2)))||
                   ' - ' || trim(left(put(&root3&i,&fmt3))) ||']';
   %end;
   %else %if &fchar = 4B %then
   %do;
    cvalue&j = put (&root1&i,&fmt1)|| ' [' || trim(left(put(&root2&i,&fmt2)))||
                   ', ' || trim(left(put(&root3&i,&fmt3))) ||']';
   %end;
   %let nvar=&j;
   %let fmt = %eval (%scan(&fmt1,1,.) +  %scan(&fmt2,1,.) + %scan(&fmt3,1,.) +6 ) ; 
   %let fmt = &fmt..;
   %let scaler =;
  %end;
 %end; * end of I loop;
%end; * end of combine loop;


%IF %length(&SCALER) > 0 %THEN %DO;
%DO J = 1 %TO &NVAR;
 &&VAR&J = &SCALER * &&VAR&J; 
%END;     
%END;     

%* DECOMPOSE LINE NUMBERS AND FIND NUMBER OF LINES;         
%IF %INDEX(&LINE,*) GT 0 %THEN %GOTO SKIPLINE;    

%LET Z = 0;         
%GLOBAL NLIN ;      
%LET NLIN = 0;      
%DO I = 1 %TO 100;  
 %LET LL=%SCAN(&LINE,&I,' ') ;
 %IF &LL EQ %STR() %THEN %GOTO LDONE3;  
 %IF %INDEX(&LL,L) GT 0 %THEN %DO;      
 %LET NLIN&I=%SCAN(&LL,2,L);  
 %LET SLIN&I=%SCAN(&LL,1,L);  
 %LET Z = %EVAL(&Z+1);        
 %GLOBAL LN&Z;      
 %LET LN&Z=&&SLIN&I;
 %LET NLIN = %EVAL(&NLIN+1);  
 %LET K = 0;        
 %DO J= 2 %TO &&NLIN&I ;      
  %LET Z = %EVAL(&Z+1);       
  %LET K = %EVAL(&K+1);       
  %LET NLIN = %EVAL(&NLIN+1); 
  %LET W=%EVAL(&Z-1);         
  %GLOBAL LN&Z;     
  %LET LN&Z=%EVAL(&&LN&W+1);  
  %IF &K EQ &XPAT %THEN %LET LN&Z=%EVAL(&&LN&Z+&NPAT) ;     
  %IF &K EQ &XPAT %THEN %LET K=0;       
  %END;   
 %END;    
 %IF %INDEX(&LL,L) EQ 0 %THEN %DO;      
  %LET Z = %EVAL(&Z+1);       
  %GLOBAL LN&Z;     
  %LET LN&Z = &LL;  
  %LET NLIN = %EVAL(&NLIN+1); 
 %END;    
%END;     
%LDONE3:  


%SKIPLINE:
%* DECOMPOSE COLUMNS AND FIND NUMBER OF COLUMNS;  
%IF %INDEX(&COL,*) GT 0 %THEN %GOTO SKIPCOL;      
%LET J=0; 
%DO I=1 %TO 100;    
 %LET CC=%SCAN(&COL,&I,' ');  
 %IF &CC EQ %STR() %THEN %GOTO DONE3;   
 %IF %INDEX(&CC,.) GT 0 %THEN %DO;      
  %LET RC1=%SCAN(&CC,1,.);    
  %LET RC2=%SCAN(&CC,2,.);    
  %IF &RC2 = %STR(0) %THEN %LET RC2 = &MAXCOL;    
  %DO K= &RC1 %TO &RC2;       
   %LET J=%EVAL(&J+1);        
   %GLOBAL BCOL&J ECOL&J OCOL&J;     
   %LET BCOL&J=&&BC&K;        
   %LET ECOL&J=&&EC&K;        
   %LET OCOL&J= &K;
  %END;   
 %END;    
 %ELSE %IF %INDEX(&CC,-) GT 0 %THEN %DO;
  %LET J=%EVAL(&J+1);         
  %LET RC1=%SCAN(&CC,1,-);    
  %LET RC2=%SCAN(&CC,2,-);    
  %IF &RC2 = %STR(0) %THEN %LET RC2 = &MAXCOL;    
   %GLOBAL BCOL&J ECOL&J OCOL&J;     
  %LET BCOL&J=&&BC&RC1;       
  %LET ECOL&J=&&EC&RC2;       
  %LET OCOL&J= &CC;
 %END;    
 %ELSE %DO;         
   %LET J=%EVAL(&J+1);        
   %GLOBAL BCOL&J ECOL&J OCOL&J;     
   %LET BCOL&J=&&BC&CC;       
   %LET ECOL&J=&&EC&CC;       
   %LET OCOL&J= &CC;
 %END;    
%END;     
%DONE3:   
%GLOBAL NCOL;       
%LET NCOL=&J;       

%SKIPCOL: 

* DO LOOP FOR HTML FILE;
%if %length(&filehtml) > 0 %then %do;
%let indent = %eval(&indent*10);
%LET IL=1;
%LET IC=1;
%LET J=0; 
%LET FOR=%SCAN(&FMT,1,.);     
%IF %INDEX(&FMT,.) = 0 %THEN %LET FMT=; 
FILE '_tabledata_.txt' noprint lrecl=500 ;

PUT       
%DO I = 1 %TO &nvar;
 %LET J=%EVAL(&J+1);
 %IF %EVAL(&J-&NVAR) GT 0 %THEN %LET J=1;         
 %LET PLINE=&&LN&IL;
 %LET PCOL=&&BCOL&IC;         
 %LET BCOL=&&BCOL&IC;         
 %LET ECOL=&&ECOL&IC;         
 %let dcol= %eval(&ecol-&bcol + 1);
 %LET PCOL=         
   %EVAL(&PCOL + (&&ECOL&IC+1-&&BCOL&IC-&FOR)/2 );
      %if &specfmt eq %str() %then %do;
       &&VAR&j &fmt  '09'x "&&LN&IL" '09'x "&&OCOL&IC" '09'x "&dcol" '09'x "&tag" '09'x "&center" '09'x "&indent" '09'x
       "&fontfamily" '09'x "&fontsize" '09'x "&fontweight" '09'x "&fontstyle"  '09'x    
       "&textdecoration" '09'x "&lineheight" '09'x "&background" '09'x "&color" /                 
      %end;
       %if &specfmt ne %str() %then %do;
       &&VAR&j &specfmt  '09'x "&&LN&IL" '09'x "&&OCOL&IC" '09'x "&dcol" '09'x "&tag" '09'x "&center" '09'x "&indent" '09'x
       "&fontfamily" '09'x "&fontsize" '09'x "&fontweight" '09'x "&fontstyle" '09'x     
       "&textdecoration" '09'x "&lineheight" '09'x "&background" '09'x "&color" /                  
       %end;
  %IF &MFIRST=L %THEN %DO;    
   %LET IL=%EVAL(&IL+1);      
   %IF %EVAL(&IL-1) EQ &NLIN %THEN %DO; 
    %LET IL=1;      
     %LET IC=%EVAL(&IC+1);    
   %END;  
  %END;   
  %IF &MFIRST=C %THEN %DO;    
   %LET IC=%EVAL(&IC+1);      
   %IF %EVAL(&IC-1) EQ &NCOL %THEN %DO; 
    %LET IC=1;      
     %LET IL=%EVAL(&IL+1);    
   %END;  
  %END;   

%END;     
;         
%end;

%LET IL=1;
%LET IC=1;
%LET J=0; 

%LET FOR=%SCAN(&FMT,1,.);     
%IF %INDEX(&FMT,.) = 0 %THEN %LET FMT=; 

FILE &filetxt print n=ps;
PUT       
%DO I = 1 %TO &nvar;
 %LET J=%EVAL(&J+1);
 %IF %EVAL(&J-&NVAR) GT 0 %THEN %LET J=1;         
 %LET PLINE=&&LN&IL;
 %LET PCOL=&&BCOL&IC;         
 %LET PCOL=         
   %EVAL(&PCOL + (&&ECOL&IC+1-&&BCOL&IC-&FOR)/2 );

 %IF &SPECIAL1 GT 0 AND &SPECIAL2 GT 0 %THEN %DO; 
      # LINE @ COLUMN &&VAR&J &FMT      
 %END;    
 %ELSE %IF &SPECIAL1 GT 0 AND &SPECIAL2 EQ %STR() %THEN %DO;
      # LINE @ &PCOL &&VAR&J &FMT       
 %END;    
 %ELSE %IF &SPECIAL2 GT 0 AND &SPECIAL1 EQ %STR() %THEN %DO;
      # &PLINE @ COLUMN &&VAR&J &FMT    
 %END;    
 %ELSE %DO;         
      %if &specfmt eq %str() %then %do;
     # &PLINE @ &PCOL &&VAR&J &FMT     
      %end;
       %if &specfmt ne %str() %then %do;
        # &PLINE @ &PCOL &&VAR&J &specfmt
       %end;
 %END;    
  %IF &MFIRST=L %THEN %DO;    
   %LET IL=%EVAL(&IL+1);      
   %IF %EVAL(&IL-1) EQ &NLIN %THEN %DO; 
    %LET IL=1;      
     %LET IC=%EVAL(&IC+1);    
   %END;  
  %END;   
  %IF &MFIRST=C %THEN %DO;    
   %LET IC=%EVAL(&IC+1);      
   %IF %EVAL(&IC-1) EQ &NCOL %THEN %DO; 
    %LET IC=1;      
     %LET IL=%EVAL(&IL+1);    
   %END;  
  %END;   

%END;     
;         

%IF &ADVL NE %STR() %THEN %DO;
 LINE=LINE+&ADVL;   
%END;     

%MEND;    


